; ----------------
; SAVE Entry Point
; ----------------
;$7F00 = RAND USR 32512

L4082:  CALL    $0F23                   ; Select FAST mode.
        LD      DE,$7F06                ; Address of the file name (byte
$CD, i.e. single character $4D).
;$7F06:
        CALL    $7F2B                   ; Perform the save.
        CALL    $0F2B                   ; Select SLOW mode.

; The following instruction (1 byte) is missing:

;       RET

; ----------------
; LOAD Entry Point
; ----------------
;$7F0D = RAND USR 32525

; The following instructions (3 bytes) are missing:

;L408F: CALL    $0F23                   ; Select FAST mode.
        LD      HL,$7F1D
        LD      ($4016),HL              ; Set CH_ADD to point at the file
name "", i.e. load any file.
        CALL    $7F70                   ; Perform the load.
        CALL    $0F2B                   ; Select SLOW mode.
        RET

; --------------
; LOAD File Name
; --------------

;$7F1D:
L409F:  DEFB    $0B                     ; File name of "".
        DEFB    $0B

; --------
; Not Used
; --------

L40A1:  DEFB    $0B, $00, $00, $00
        DEFB    $00, $00, $00, $CD
        DEFB    $A8, $03, $38, $F9

; ------------
; SAVE Routine
; ------------

;$7F2B:
L40AD:  EX      DE,HL
        LD      DE,$12CB

; Output 5 seconds of silence.

L40B1:  CALL    $0F46
        JR      NC,L40E4

L40B6:  DJNZ    L40B6

        DEC     DE
        LD      A,D
        OR      E
        JR      NZ,L40B1

; Output file name bytes.

L40BD:  CALL    $7F4E

        BIT     7,(HL)
        INC     HL
        JR      Z,L40BD

; Output program bytes.

        LD      HL,$4009

L40C8:  CALL    $7F4E
        CALL    $01FC
        JR      L40C8

; Output byte routine
; -------------------

;$7F4E:
L40D0:  LD      E,(HL)
        SCF

; Output bit.

L40D2:  RL      E
        RET     Z

        SBC     A,A
        AND     $02                     ; $02 or $00. Different to the ROM
routine which uses AND $05 (results in $05 or $00).
        ADD     A,$01                   ; $03 or $01. Different to the ROM
routine which uses ADD A,$04 (results in $09 or $04).
        LD      C,A

L40DB:  OUT     ($FF),A

        LD      B,$23

L40DF:  DJNZ    L40DF

        CALL    $0F46

L40E4:  JR      NC,L4158

        LD      B,$1E

L40E8:  DJNZ    L40E8

        DEC     C
        JR      NZ,L40DB

        JP      $7FD8

;$7F6E:
L40F0:  JR      L40D2

; ------------
; LOAD Routine
; ------------

;$7F70:
L40F2:  CALL    $03A8
        RL      D
        RRC     D

L40F9:  CALL    $7F7C
        JR      L40F9

; Input byte routine
; ------------------

;$7F7C:
L40FE:  LD      C,$01

; Read next bit.

L4100:  LD      B,$00

L4102:  LD      A,$7F
        IN      A,($FE)
        OUT     ($FF),A
        RRA
        JR      NC,L4154

        RLA
        RLA
        JR      C,L4137

        DJNZ    L4102

        POP     AF
        CP      D
L4113:  JP      NC,$03E5

        LD      H,D
        LD      L,E

L4118:  CALL    $7F7C

        BIT     7,D
        LD      A,C
        JR      NZ,L4123

; The following instructions (23 bytes) are missing:

;       CP      (HL)
;       JR      NZ,L40F9

;L4123: INC     HL
;       RLA
;       JR      NC,L4118

;       INC     (IY+$15)
;       LD      HL,$4009

;L412D: LD      D,B
;       CALL    $7F7C
;       LD      (HL),C

;       CALL    $01FC
;       JR      L412D

; Read bit routine
; ----------------

; The following instructions (9 bytes) are missing.

;L4137: PUSH    DE
;       LD      E,$31                   ; Different to the ROM routine which
uses a value of $94.

;L413A: LD      B,$1A

;L413C: DEC     E
;       IN      A,($FE)
;       RLA

        BIT     7,E
        LD      A,E
        JR      C,L413A

        DJNZ    L413C

        POP     DE
        JR      NZ,L414E

        CP      $56
        JR      NC,L4100

L414E:  CCF
        RL      C
        JR      NC,L4100

        RET

L4154:  LD      A,D
        AND     A
        JR      Z,L4113

L4158:  RST     08H
        DEFB    $0C

; Output delay between bits.

;$7FD8:
L415A:  AND     A
        LD      B,$50

L415D:  DJNZ    L415D

        JP      $7F6E

; ----------------
; TRANSFER Routine
; ----------------
; Copy the save and load routines above RAMTOP.
; RAND USR 16738

L4162:  LD      HL,L4082
        LD      DE,$7F00
        LD      BC,L4162-L4082
        LDIR

        LD      HL,$7EFF
        LD      ($4004),HL              ; RAMTOP
        JP      $03C3                   ; NEW command

